Json::Value g_json;
[Setting name="Manifest" category="General" description="The URL of the manifest file that contains the information about all Evo servers"]
string Setting_Manifest_URL = "https://openplanet.dev/plugin/evo/config/servers";	

void RenderMenu()
{
  auto app = cast<CTrackMania>(GetApp());
  auto canJoinServers = Permissions::PlayPublicClubRoom();
  if(UI::BeginMenu("\\$f05" + Icons::Gamepad + " \\$fffEvo")){
    if(UI::BeginMenu("\\$f05" + Icons::Server + " \\$fffJoin our servers", canJoinServers )){
      for(uint i = 0; i < g_json.Length; i++) {
        string servername = g_json[i].Get("servername");
        string joinlink = g_json[i].Get("joinlink");
        if(UI::MenuItem("\\$f05" + Icons::PlayCircle + "\\$fff" + servername, "", false, canJoinServers)) {
          app.ManiaPlanetScriptAPI.OpenLink(joinlink, CGameManiaPlanetScriptAPI::ELinkType::ManialinkBrowser);
        }
      }
      UI::EndMenu();
    }
    UI::Separator();
    if (UI::MenuItem("\\$f05" + Icons::Discord + "\\$fff Discord")) {
      OpenBrowserURL("https://discord.gg/evoesports");
    }
    if (UI::MenuItem("\\$f05" + Icons::Facebook + "\\$fff Facebook")) {
      OpenBrowserURL("https://www.facebook.com/EvoTrackmania");
    }
    if (UI::MenuItem("\\$f05" + Icons::Mastodon + " \\$fff Mastodon")) {
      OpenBrowserURL("https://trackmania.social/@evo");
    }
    if (UI::MenuItem("\\$f05" + Icons::Steam + "\\$fff Steam")) {
      OpenBrowserURL("https://steamcommunity.com/groups/evoesportsev");
    }
    if (UI::MenuItem("\\$f05" + Icons::Twitch + "\\$fff Twitch")) {
      OpenBrowserURL("https://www.twitch.tv/evotrackmania");
    }
    if (UI::MenuItem("\\$f05" + Icons::Twitter + "\\$fff Twitter")) {
      OpenBrowserURL("https://twitter.com/EvoTM");
    }
    if (UI::MenuItem("\\$f05" + Icons::Youtube + "\\$fff YouTube")) {
      OpenBrowserURL("https://www.youtube.com/@EvoTrackmania");
    }
    UI::EndMenu();
  }
}

void Main()
{
  print ("Downloading latest Evo server list...");
  auto response = Net::HttpGet(Setting_Manifest_URL);
  while(!response.Finished()) {
    yield();
  }
  g_json = Json::Parse(response.String());
  print ("Successfully parsed Evo server list!");
  yield();
}